from BaseAI import *

"""
Sample values pass:
    data={}
    data['target']= ship_to_shoot
"""

class Attack(BaseAI):

    def __init__(self, ship, values = None):
        
        BaseAI.__init__(self, ship)
        
        if not values.has_key('target'):
            self.pop_ai()
        else:
            self.mytarget = values['target']
            
        if not values.has_key('radius'):
            self.radius = 50
        else:
            self.radius = values['radius']

        if values.has_key('initial'):
            self.ship.pos = values['initial']
        
    def update(self, dt = 0):
        self.ship.firing = False

        if self.ship.dist(ship=self.mytarget) > self.ship.sensor_range or self.mytarget.cloaked:
            self.radius = 0
            self.pop_ai()
        elif self.ship.dist(ship=self.mytarget) < self.ship.weapon.range+self.ship.radius and not self.mytarget.cloaked:
            self.ship.firing = True
        
        self.set_course(self.mytarget.pos, dt)
        
        return BaseAI.update(self, dt)
