# This code modified from:
# http://www.daniweb.com/techtalkforums/thread30215.html


import sys, re
# -- Loads a config file, creates and returns a dictionary
def load(filename, defaults = None):
    try: 
        configfile = open(filename, "r")
    except Exception, e: 
        raise
    try: 
        configtext = configfile.read()
    except Exception, e: 
        raise
    # Compile a pattern that matches our key-value line structure
    pattern = re.compile("\\n([\w_]+)[\t ]*([\w: \\\/~.-]+)")
    # Find all matches to this pattern in the text of the config file
    tuples = re.findall(pattern, configtext)
    # Create a new dictionary and fill it: for every tuple (key, value) in
    # the 'tuples' list, set ret[key] to value 
    ret = dict()
    for x in tuples: 
        ret[x[0]] = x[1]
        
    if defaults:
        for key in defaults:
            if key not in ret:
                ret[key] = defaults[key]
        
    # Return the fully-loaded dictionary object
    return ret
     
# Addition by Jay for pyweek
def save(dict, filename):
    try:
        configfile = open(filename, "w")
    except Exception, e:
        raise
    
    configfile.write("#This file is automatically generated.\n")
    for key in dict:
        string = str(key) + "   " + str(dict[key]) + "\n"
        configfile.write(string)
        
    configfile.flush()
    configfile.close()
     
# -- Main method (diagnostic)
def main(args):
     # Set a default filename
     filename = "doc\Config.cfg"
     # If there is a command-line argument, treat it as a filename
     if len(args) > 1: filename = args[1]
     # Run the load function and deal with any possible exceptions
     try: cfg = load(filename)
     except Exception, e:
          print "ERROR:", filename+":", e.args[1]
          sys.exit(1)
     # Print each key-value pair in the dictionary, terminate gracefully
     for x in cfg: print x, "\t", cfg[x]
     sys.exit(0)
# -- Call main if this program is being invoked from the command-line
if __name__ == "__main__": main(sys.argv)