
import gutil

from putil import *

from Image import Image
from Text import Text

from Player import Player

from Ai import Ai

from Ship import Ship

import pygame
from pygame.locals import *

import globals
from globals import *
from Config import *

from LevelLoader import LevelLoader

targetFPS = 60


class Engine:
    def __init__(self):
        self.bg = Image('big_stars')

        self.deadText = Text("Game Over",   fontsize=70, color = (200,200,200,255))
        self.winText = Text("You Win!", fontsize=70, color = (200,200,200,255))
        
        self.showSplash = False
        
        self.loader = LevelLoader(self)
        
        self.level = self.loader.getLevel() 
        
        self.level.initLevel()
        
        self.clock = pygame.time.Clock()
    


    def update(self):
        dt = (self.clock.tick() / (1000.0/targetFPS)) # at targetFPS, dt == 1.0
        flag = False
        self.bg.draw([0,0],width=DWIDTH, height=DHEIGHT)

        if self.showSplash:
            self.splash.draw()
        else:
        
            levelStatus = self.level.getStatus()
            
            if levelStatus['win']:
                self.player.ship.weapon.channel.stop()
                if self.loader.levelNum < self.loader.numLevels - 1:
                    self.level = self.loader.nextLevel()
                    if self.loader.levelNum > globals.config['max_level']:
                        globals.config['max_level'] = self.loader.levelNum
                        save(globals.config, globals.config_filename)
                    self.level.initLevel()
                else:
                    self.winText.draw(pos=(400,350))
            elif levelStatus['lose']:
                self.player.ship.weapon.channel.stop()
                self.level.initLevel()
            else:
                globals.enemyList = filter(lambda x : not x.dead, globals.enemyList)
            
                self.player.update(dt)
                for enemy in globals.enemyList:
                    enemy.update(dt)
                    if enemy.ship.weapon.firing:
                        flag = True
                
    
                # Whee!!! lets draw using a list comprehension.
                [object.draw() for object in globals.objectList]
                
                self.player.draw()
                if self.player.ship.weapon.firing:
                    flag = True
                if not flag:
                    self.player.ship.weapon.channel.stop()
                
                # now lets draw with map!!!
                map(lambda enemy: enemy.draw(), globals.enemyList) 
                
                self.player.draw2()

        
        
    def handleKeyboardEvent(self, event):
        if self.showSplash:
            if event.type == KEYDOWN and event.key == K_SPACE:
                self.showSplash = False
        else:
            if event.type == KEYDOWN and event.key == K_r:
                self.level.initLevel()
            if event.type == KEYDOWN and event.key == K_k:
                self.level = self.loader.nextLevel()
                self.level.initLevel()


            self.player.handleKeyboardEvent(event)
