
import Levels

class LevelLoader:
    def __init__(self,engine):
        self.levels = []
        self.engine = engine
        done = False
        i = 1
        while not done:
            try:
                level = getattr(Levels, "Level%d" % i)
            except:
                done = True
            else:
                self.levels.append(level)
                i += 1
                
        self.levelNum = 0
        self.currentLevel = self.levels[self.levelNum](engine)
        self.numLevels = len(self.levels)
    
    def getLevel(self):
        return self.currentLevel
        
    def nextLevel(self):
        self.levelNum += 1
        if self.levelNum >= len(self.levels):
            self.levelNum = 0
            
        self.currentLevel = self.levels[self.levelNum](self.engine)
        return self.currentLevel
            
    def setLevel(self, level = 0):
        self.levelNum = level
        if self.levelNum >= len(self.levels):
            self.levelNum = 0
        elif self.levelNum < 0:
            self.levelNum = 0
            
        self.currentLevel = self.levels[self.levelNum](self.engine)