from BaseAI import *
import random

class MineAI(BaseAI):

    def __init__(self, ship, values = None):
        
        BaseAI.__init__(self, ship)
        
        if not values.has_key('target'):
            self.pop_ai()
        else:
            self.mytarget = values['target']
            
        if not values.has_key('radius'):
            self.radius = 50
        else:
            self.radius = values['radius']

        if values.has_key('initial'):
            self.ship.pos = values['initial']
            
        self.ship.rotation = random.randrange(0,360)
        
    def update(self, dt = 0):
        self.ship.firing = False

        if self.ship.dist(ship=self.mytarget) < self.ship.sensor_range and not self.mytarget.cloaked:
            self.set_course(self.mytarget.pos, dt)
            if self.ship.dist(ship=self.mytarget) < self.ship.weapon.range+self.ship.radius:
                self.ship.firing = True
        
        return BaseAI.update(self, dt)
        
    def keep_course(self, dt = 0):
        distance = self.ship.dist(pos = self.moving_to)
        self.target[0] = self.moving_to[0] - self.ship.velocity[0]
        self.target[1] = self.moving_to[1] - self.ship.velocity[1]  

        x1, y1 = self.ship.pos
        x2, y2 = self.target
        
        if y1 == y2:
            beta = 90.0
        else:
            beta = abs(degrees(atan((x1-x2)/(y1-y2))))
        if y1 > y2:
            if x1 > x2:
                quad = 2
            else:
                quad = 1
                beta = 90- beta
        else:
            if x1 > x2:
                quad = 3
                beta = 90 - beta
            else:
                quad = 0
        theta = beta + 90*quad

        if abs(x1-x2) < self.fudge and y1 < y2:
            theta = 0
        if abs(x1-x2) < self.fudge and y1 > y2:
            theta = 180
        if abs(y1-y2) < self.fudge and x1 < x2:
            theta = 90           
        if abs(y1-y2) < self.fudge and x1 > x2:
            theta = 270
            

            
        if theta > self.ship.rotation + self.turnfudge:
            self.ship.rotateDir = 1
        elif theta < self.ship.rotation - self.turnfudge:
            self.ship.rotateDir = -1
        else:
            self.ship.rotateDir = 0
            
        if abs(theta - self.ship.rotation) > 180:
            self.ship.rotateDir *= -1

        if self.ship.percision_override:
            self.ship.rotation = theta
            
        self.last_angle = theta

