
from Image import Image

class Object:
    def __init__(self, pos, imageName, width, height):
        self.image = Image(imageName)
        self.pos = pos[:]
        self.width = width
        self.height = height
        self.radius = width / 2.0
        self.velocity = [0,0]
        self.mass = 10000
        self.health = 10000
        self.dead = False
    
    def draw(self):
        self.image.draw(pos = (self.pos[0] - self.width/2.0, self.pos[1] - self.height/2.0), width=self.width, height = self.height)
        
        
class SmallMoon(Object):
    def __init__(self, pos):
        Object.__init__(self, pos, 'neptunex', 50, 50)
        
class WayPoint(Object):
    def __init__(self, pos):
        Object.__init__(self, pos, 'ping', 50, 50)
        
    def draw(self):
        self.image.draw(pos = (self.pos[0] - self.width/2.0, self.pos[1] - self.height/2.0), width=self.width, height = self.height, color=[0.2,0.9,0.3,1.0])
    