from Image import Image
from math import *
from random import *
import Particles

class ParticleFountain:
    
    def __init__(self, 
                    image = 'spark',
                    pos = [0,0],
                    rotation = 0,
                    thrustVel = 10,
                    ttl = 5,
                    rate = 2,
                    size = 4,
                    particletype = 'Particle'):
        self.image = image
        self.particletype = particletype = getattr(Particles, particletype)
        self.pos = pos[:]
        self.rotation = rotation
        self.thrustVel = thrustVel
        self.ttl = ttl
        self.rate = rate
        self.parts = []
        self.size = size
        self.firing = False

    def update(self, dt, pos, rotation, firing):

        self.pos = pos[:]
        self.rotation = rotation
        self.firing = firing
        
        # first go through the list and update the
        # particles already in existence

        for particle in self.parts:
            particle.update(dt)

        # now kill all the dead ones
        # note that we're relying on the fact the oldest particles are
        # first in the list
        """sliceat = 0
        max_sliceat = len(self.parts) - 1
        if len(self.parts) > 0:
            while (sliceat < max_sliceat and self.parts[sliceat].transparency <= 0):
                sliceat += 1
            self.parts = self.parts[sliceat:]"""
        
        # this also works:
        self.parts = filter(lambda part : part.transparency > 0, self.parts)

        # now add any new ones
        if self.firing:
            for x in range(self.rate):
                self.parts.append(self.particletype(self.image, self.pos, self.rotation, self.thrustVel, self.ttl, self.size))

    
    def draw(self):
        for part in self.parts:
            part.draw()

