from Image import *
from math import *
from random import *


class Particle:
    def __init__(self, image, pos, rotation, thrustVel, ttl, size):
        global imageCache
        if not imageCache.has_key(image):
            imageCache[image] = Image(image)
        self.image = imageCache[image]
        self.pos = [pos[0] - size / 2.0, pos[1] - size / 2.0]
        self.thrustVel = thrustVel
        self.transparency = 1
        self.ttl = ttl
        # we randomize the direction of the fire a bit to give that nice firey effect
        self.xdt = -sin(radians(rotation)) + randrange(-1,2) * random() * self.thrustVel * 0.01
        self.ydt = -cos(radians(rotation)) + randrange(-1,2) * random() * self.thrustVel * 0.01
        self.size = size
        
    def update(self,dt):
        self.transparency -= dt / self.ttl
        self.pos[0] += dt * self.thrustVel * self.xdt
        self.pos[1] += dt * self.thrustVel * self.ydt
    
    def draw(self):
        self.image.draw(pos = self.pos, height = self.size, width = self.size, color = [1.0,1.0,1.0,self.transparency])

class ReverseParticle(Particle):
    def __init__(self, image, pos, rotation, thrustVel, ttl, size):
        Particle.__init__(self, image, pos, rotation, thrustVel, ttl, size)
        self.xdt = self.xdt * -1
        self.ydt = self.ydt * -1

class RandomParticle(Particle):
    def __init__(self, image, pos, rotation, thrustVel, ttl, size):
        Particle.__init__(self, image, pos, randrange(0,360), thrustVel, ttl, size)

        
class SparkParticle(RandomParticle):
    def draw(self):
        color = [uniform(0,1),uniform(0,1),uniform(0,1),self.transparency]
        self.image.draw(pos = self.pos, height = self.size, width = self.size, color = color)

        

global imageCache
imageCache = {}
