from Ship import *
from math import *

class HeroShip(Ship):
    def __init__(self):
        Ship.__init__(self, 'heroship',pos=[200,200], size=32,friction=0.025)

    def updateExhaust(self, dt):
        # first two go forward, last two go back
        
        # we make and array with the current firing values (because I can't pass a boolean variable by reference!)
        ef = [self.thrust, self.thrust, self.reverseThrust, self.reverseThrust]
        
        for e in range(len(self.exhaust)):
            dx2 = self.engine_offsets[e][3] * sin(radians(self.rotation - self.engine_offsets[e][2]))
            dy2 = self.engine_offsets[e][3] * cos(radians(self.rotation - self.engine_offsets[e][2]))
            self.exhaust[e].update(dt, [self.pos[0]+dx2, self.pos[1]+dy2], self.rotation, ef[e])

    def initEngines(self):
        # we calculate the initial angular offset of the engines so we can take the difference later
        self.engine_offsets = [[-10.0,-5.0], [10.0,-5.0], [-5.0, 12.0], [5.0,12.0]]
        for x in self.engine_offsets:
            offset = degrees(tan(x[0] / x[1]))
            if offset < 0:
                offset += 360
            x.append(offset)
            x.append((x[0]**2 + x[1]**2)**0.5)

        return [ParticleFountain(), ParticleFountain(), ParticleFountain(particletype = 'ReverseParticle'), ParticleFountain(particletype = 'ReverseParticle')]
        
class SmallHero(HeroShip):
    def __init__(self):
        Ship.__init__(self, 'heroship',pos=[200,200], size=20,friction=0.0,  rotateVel = 2.5, accel = 0.03,maxVel = 1.9)