from BaseAI import *
from Image import Image

"""
Sample values pass:
    data={}
    data['patrol_points']=[[0,0], [200,200],]
    data['random']=True
    data['size']=((0,0), (100,100))
    data['ammount']=0
    data['passive=True']

"""


class Patrol(BaseAI):
    
    def __init__(self, ship, values={}):
        BaseAI.__init__(self, ship)
        
        self.patrol_points = []
        self.next_point = 0
        self.passive = False
        
        if not values.has_key('random'):
            self.patrol_points = values['patrol_points'][:]
        else:
            self.patrol_points = []
            min, max = values['size']
            min_x, min_y = min
            max_x, max_y = max
            for i in range(ammount):
                point = (random(min_x, max_x), random(min_y, max_y))
                self.patrol_points.append(point)
        self.ship.pos = self.patrol_points[0][:]
        self.next_point = 1
        self.moving_to = self.patrol_points[self.next_point]
        if values.has_key('passive'):
            self.passive = True

    def update(self, dt = 0):
        x1, y1 = self.moving_to
        x2, y2 = self.ship.pos
        if (abs(x1 - x2) < self.fudge) and (abs(y1 - y2) < self.fudge):
            self.set_course(self.patrol_points[self.next_point], dt)
            self.next_point += 1
            if self.next_point > len(self.patrol_points)-1:
                self.next_point = 0
        else:
            self.keep_course(dt)
        return BaseAI.update(self, dt)
        
    def draw(self):
        if self.debug:
            for loc in self.patrol_points:
                self.ping.draw(pos = loc)

        BaseAI.draw(self)
            
    def see_threat(self, target = None):
        if not self.passive:
            self.push_ai("Attack", target)